﻿Type=Class
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Public Sub Class_Globals
	Type lgGraphics (Width As Int, Height As Int, FramesPerSecond As Int, DeltaTime As Double, RawDeltaTime As Double)	
	
	Dim lgCanvas         As Canvas
	Dim lgCycle          As Timer	
	Dim Graphics         As lgGraphics	
	Private lgTimeStamp  As Long
End Sub

Public Sub Initialize
	Graphics.Width  = Main.MainForm.Width
	Graphics.Height = Main.MainForm.Height
	lgCanvas.Initialize("lgCanvas")
	Main.MainForm.RootPane.AddNode(lgCanvas, 0, 0, Main.MainForm.Width, Main.MainForm.Height)
	Main.LG_Create
	Main.LG_Resize(Graphics.Width, Graphics.Height)
	lgTimeStamp = DateTime.Now
	lgCycle.Initialize("lgCycle", 1)
	lgCycle.Enabled = True	
End Sub

Public Sub InitializeView(Name As String) As View
	Graphics.Width  = Main.MainForm.Width
	Graphics.Height = Main.MainForm.Height
	lgCanvas.Initialize("lgCanvas")
	Main.MainForm.RootPane.AddNode(lgCanvas, 0, 0, Main.MainForm.Width, Main.MainForm.Height)
	Main.LG_Create
	Main.LG_Resize(Graphics.Width, Graphics.Height)
	lgTimeStamp = DateTime.Now
	lgCycle.Initialize("lgCycle", 1)
	lgCycle.Enabled = True
	Dim DummyView As View
	Return DummyView
End Sub

Sub lgCycle_Tick
	Graphics.DeltaTime       = Max(1, (DateTime.Now - lgTimeStamp)) / 1000
	Graphics.RawDeltaTime    = Graphics.DeltaTime
	Graphics.FramesPerSecond = Round(1 / Graphics.DeltaTime)	
	lgCanvas.ClearRect(0, 0, Main.MainForm.Width, Main.MainForm.Height)
	Main.LG_Render
	lgTimeStamp = DateTime.Now
End Sub

Sub Pause
	lgCycle.Enabled = False
End Sub

Sub Resume
	lgCycle.Enabled = True
End Sub

Sub Stop
	Main.LG_Dispose
End Sub